const XLSX = require("xlsx");
const fs = require("fs");
const carbone = require("carbone");
const path = require("path");
const log4js = require("log4js");

globalFunctions = {};


// TODO: = = = = = UTILES = = = = = 
// * Subrutina dateFunction. Retorna hora y/o fecha.
globalFunctions.dateFunction = (param) => {
	let today = new Date();
	let date =
		today.getDate() +
		"-" +
		(today.getMonth() + 1) +
		"-" +
		today.getFullYear();
	let hour =
		today.getHours() + "-" + today.getMinutes() + "-" + today.getSeconds();
	let dateNhour = date + "_" + hour;
	switch (param) {
		case "date":
			return date;
			break;
		case "hour":
			return hour;
			break;
		case "dateNhour":
			return dateNhour;
			break;
	}
};

globalFunctions.dateFunctionSinGuiones = (param) => {
	let today = new Date();
	let date = `${today.getFullYear()}${(today.getMonth() + 1)}${today.getDate()}`;
	let hour = `${today.getHours()}${today.getMinutes()}${today.getSeconds()}`;
	let dateNhour = `${date}${hour}`;
	switch (param) {
		case "date":
			return date;
		case "hour":
			return hour;
		case "dateNhour":
			return dateNhour;
	}
};

// * Estados y mensajes
globalFunctions.statusMsg = (param) => {
	switch (param) {
		case 0:
			return { status: 0, status_message: "Failed.", status_message_description: "Algo salió mal, intenta nuevamente." }
		case 1:
			return { status: 1, status_message: "Success.", status_message_description: "Acción con éxito." }
		case 2:
			return { status: 2, status_message: "Exists.", status_message_description: "Ya existe." }
		case 3:
			return { status: 3, status_message: "Inactive.", status_message_description: "Acción inactiva." }
		case 4:
			return { status: 4, status_message: "No results.", status_message_description: "No hay resultados a mostrar, intenta nuevamente." }
		case 5:
			return { status: 5, status_message: "Authorization error.", status_message_description: "Algo salió mal en la autorización, intenta nuevamente." }
		case 6:
			return { status: 6, status_message: "Duplicate entry.", status_message_description: "Entrada duplicada." }
	}
}

globalFunctions.logger = (data, type, msg) => {
	const levelType = ['all', 'trace', 'debug', 'info', 'warn', 'error', 'fatal'];
	const logger = log4js.getLogger();

	if (!levelType.includes(type)) {
		console.log(type)
		logger.level = 'error';
		logger.error('Error al asignar tipo de logger.');
	} else {
		logger.level = type;
	}

	switch (type) {
		case 'trace': logger.trace(`[${data.method}] -> ${data.host} ${data.url} - usr: ${data.username} - msg: ${msg}`); break;
		case 'debug': logger.debug(`[${data.method}] -> ${data.host} ${data.url} - usr: ${data.username} - msg: ${msg}`); break;
		case 'info': logger.info(`[${data.method}] -> ${data.host} ${data.url} - usr: ${data.username} - msg: ${msg}`); break;
		case 'warn': logger.warn(`[${data.method}] -> ${data.host} ${data.url} - usr: ${data.username} - msg: ${msg}`); break;
		case 'error': logger.error(`[${data.method}] -> ${data.host} ${data.url} - usr: ${data.username} - msg: ${msg}`); break;
		case 'fatal': logger.fatal(`[${data.method}] -> ${data.host} ${data.url} - usr: ${data.username} - msg: ${msg}`); break;
	}
}

globalFunctions.location_url = (url) => {
	let locationParam = url;

	let locationNoProtocol = locationParam.replace("http://", "");
	let locationResult = locationNoProtocol.replace(
		locationNoProtocol.split("/").pop(),
		"",
	);
	let locationNew = locationResult.slice(0, -1);
	return locationNew;
}

// TODO: = = = = = REPORTES = = = = = 
// * Nombre del reporte
globalFunctions.filenameReporte = (tipoReporteParam, dateParam, extensionParam) => {
	// return "../reportes/" + tipoReporteParam + "/reporte_" + dateParam + "." + extensionParam;
	let filename = "reporte_" + dateParam + "." + extensionParam;
	return path.join(__dirname, "..", "..", "reportes", tipoReporteParam, filename);
}

// * Suma de cantidad de registros
globalFunctions.sumaCantidadRegistros = (arrayParam) => {
	let cantArray;
	for (let i = 0; i < arrayParam.length; i++) {
		// cantArray.push({id: i});
		cantArray = i;
		arrayParam[i].registro = i;
	}
	return arrayParam;
}

// * Suma de "X" elemento de cada arreglo
globalFunctions.sumaElemento = (arrayParam, elemento) => {
	let sum = 0.00;
	arrayParam.forEach(array => {
		sum += array[elemento];
	});
	return sum.toFixed(2);
}

// ! DEPRECATED: Suma de "X" elemento de cada arreglo test
globalFunctions.sumaElemento_test = (arrayParam, elemento) => {
	let sum = 0.00;
	let i = 0;
	do {
		console.log('elemento ' + [i] + ' :> ', elemento);
		this_elemento = elemento;
		console.log('arrayParam[i][this_elemento] :> ', arrayParam[i][this_elemento]);
		sum += arrayParam[i][this_elemento];
		i++;
	} while (i < arrayParam.length);
	return sum.toFixed(2);
}

// ! DEPRECATED: Suma del "cant:" de cada arreglo
globalFunctions.sumaCantidad = (arrayParam) => {
	let sumCantidad = 0.00;
	arrayParam.forEach(array => {
		sumCantidad += array.cant;
	});
	return sumCantidad.toFixed(2);
	// return sumCantidad;
}

// ! DEPRECATED: Suma del "total:" de cada arreglo
globalFunctions.sumaTotal = (arrayParam) => {
	let sumTotal = 0.00;
	arrayParam.forEach(array => {
		sumTotal += array.total;
	});
	return sumTotal.toFixed(2);
	// return sumTotal;
}

// ! DEPRECATED: Suma del "descuento:" de cada arreglo
globalFunctions.sumaDescuento = (arrayParam) => {
	let sumDescuento = 0.00;
	arrayParam.forEach(array => {
		sumDescuento += array.descuento;
	});
	return sumDescuento.toFixed(2);
	// return sumDescuento;
}

// * Procesamiento de datos del reporte
globalFunctions.datosReporteMatrix = (empresaParam, fechaInicioParam, fechaFinParam, cantParam, sumaTotalParam, arrayParam) => {
	let newArray = [];
	const data = {
		empresa: empresaParam,
		fechaInicio: fechaInicioParam,
		fechaFin: fechaFinParam,
		sumaCant: cantParam,
		sumaTotal: sumaTotalParam,
		autorizacionFEL: "AUTORIZACIÓN FEL.",
		cant: "CANT.",
		cantidad: 'CANTIDAD',
		cajero: 'CAJERO',
		companiaAerea: 'LINEA AEREA',
		correlativo: "CORRELATIVO",
		descripcion: "DESCRIPCION",
		descLarga: 'DESC. LARGA',
		descuento: "DESCUENTO",
		direccion: 'DIRECCION',
		estado: 'ESTADO',
		fecha: "FECHA",
		Fecha: 'FECHA EMISION',
		fechaFactura: "FECHA FRA.",
		iva: "IVA",
		moneda: 'MONEDA',
		nit: "NIT",
		nombre: "NOMBRE",
		precioUnitario: 'PRECIO UNITARIO',
		vendedor: 'VENDEDOR',
		valorFactura: "VALOR FRA.",
		registro: "#",
		serie: "SERIE",
		sku: "SKU",
		subtotal: "SUBTOTAL",
		total: "VENTA TOTAL"
	};
	newArray.push(data, ...arrayParam)
	return newArray;
}

// * Creacion de reporte XLSX
globalFunctions.reporteJsonToXLSX = (dateParam, jsonParam, tipoReporteParam) => {
	if (typeof jsonParam != "object") {
		console.log("Los datos no son de tipo JSON :> ");
	} else if (typeof jsonParam == "object") {
		let workbook = XLSX.utils.book_new();
		let fileName = "reporte_" + dateParam;
		let fileNameExt = "reportes_xlsx/" + tipoReporteParam + "/reporte_" + dateParam + ".xlsx";
		workbook.Props = {
			Title: "reporte",
			Subject: "",
			Author: "",
			CreatedDate: dateParam,
		};
		workbook.SheetNames.push("Reporte");
		let ws = XLSX.utils.json_to_sheet(jsonParam);
		workbook.Sheets["Reporte"] = ws;
		let wbout = XLSX.write(workbook, {
			booktype: "xlsx",
			type: "binary",
		});

		const file = XLSX.writeFile(workbook, fileNameExt);
		return file;
	}
};

// *
globalFunctions.carboneReporteJSON2XLSX = (jsonParam, fileNameParam, tipoReporteParam) => {
	switch (tipoReporteParam) {
		case "reportes_fecha":
			carbone.render(
				"assets/docs/VentasPorFecha_Template.xlsx",
				jsonParam,
				function (err, result) {
					if (err) {
						console.log("error :> ", err);
					}
					fs.writeFileSync(fileNameParam, result);
				},
			);
			break;
	}
}

// *
globalFunctions.sheetToArraybuffer = (sheet) => {
	var buf = new ArrayBuffer(sheet.length);
	var view = new Uint8Array(buf);
	for (var i = 0; i < sheet.length; i++) view[i] = sheet.charCodeAt(i) & 0xff;
	return buf;
};

// TODO: = = = = = CARGA MASIVA = = = = = 


module.exports.globalFunctions = globalFunctions;
